#ifndef __population_h
#define __population_h

/*
 *  Population of solutions
 */

#include <fstream>
#include <vector>
#include <string>

#include <solution.h>

using namespace std;

class Population : public std::vector<Solution>
{
public:
  Population() : std::vector<Solution>() {
  }

  Population(const Population & _p) : std::vector<Solution>(_p) {
  }

  Population& operator=(const Population & _p) {
    this->resize(_p.size());

    for(unsigned int i = 0; i < _p.size(); i++)
      this->operator[](i) = _p[i];

    return *this;
  }

  /**
   * print the solution
   */
  virtual void printOn(std::ostream& _os) const {
    std::cout << this->size() << std::endl;

    for(unsigned i = 0; i < this->size(); i++) 
	  std::cout << (this->operator[](i)) << std::endl;

  }

};

std::ostream & operator<<(std::ostream& _os, const Population & _p) {
    _p.printOn(_os);
    return _os;
}

#endif