#ifndef __rnd_h
#define __rnd_h

/*
 * Random solution
 */

#include <fstream>
#include <vector>
#include <string>
#include <random>

#include <solution.h>

using namespace std;

class RandomSolution
{
public:
    RandomSolution(std::mt19937 & _rnd_gen, unsigned _n) : rnd_gen(_rnd_gen), n(_n) {

    }

    virtual void operator()(Solution & x) {
        std::uniform_int_distribution<> dis(0, 1);

        x.resize(n);
        
        for(unsigned i = 0; i < x.size(); i++)
            x[i] = (dis(rnd_gen) == 0);
    }

protected:
    std::mt19937 & rnd_gen;

    unsigned n;

};

#endif