#ifndef _solution_h
#define _solution_h

#include <iostream>
#include <vector>

/**
   Classe pour représenter une solution
   
   Chaine de bits auquel est ajoutée le vector des valeurs objectifs, et une valuer scalaire qui aggrége les objectifs
*/
class Solution : public std::vector<bool> {
public:
  Solution() : std::vector<bool>() {
    scalar_fitness = 0.0;
  }

  Solution(const Solution & _s) : std::vector<bool>(_s) {
    objective_vector.resize(_s.objective_vector.size());

    for(unsigned int i = 0; i < _s.objective_vector.size(); i++)
      objective_vector[i] = _s.objective_vector[i];

    scalar_fitness = _s.scalar_fitness;
  }

  Solution& operator=(const Solution & _s) {
    this->resize(_s.size());
    for(unsigned int i = 0; i < _s.size(); i++)
      this->operator[](i) = _s[i];

    objective_vector.resize(_s.objective_vector.size());
    for(unsigned int i = 0; i < _s.objective_vector.size(); i++)
      objective_vector[i] = _s.objective_vector[i];

    scalar_fitness = _s.scalar_fitness;

    return *this;
  }

  /**
   * print the solution
   */
  virtual void printOn(std::ostream& _os) const {
    std::cout << objective_vector.size() ;
    for(unsigned i = 0; i < objective_vector.size(); i++)
      std::cout << " " << objective_vector[i] ;

    std::cout << " " << scalar_fitness ;

    std::cout << " " ;
    for(unsigned int i = 0; i < this->size(); i++)
      std::cout << this->operator[](i) ;

  }

  // objective vector
  std::vector<double> objective_vector;

  // fitness value : scalar value of agregated objectives
  double scalar_fitness;

};

std::ostream & operator<<(std::ostream& _os, const Solution & _s) {
    _s.printOn(_os);
    return _os;
}

#endif
