/*
 Author: Sebastien Verel, Univ. du Littoral Côte d'Opale, France
 Date: 2020/10/16, Version 1
*/

#ifndef _weigthedFitness_h
#define _weigthedFitness_h

#include <fstream>
#include <vector>

#include <solution.h>

class WeightedFitness {
public:
	WeightedFitness(vector<double> & _weights) : weights(_weights) {

	}

	/*
		Compute aggregate value of objective vector

		We suppose that objective values are up to date
	*/
	void operator()(Solution & _solution) {
		double fit = 0.0;

		for(unsigned i = 0; i < _solution.objective_vector.size(); i++)
			fit += weights[i] * _solution.objective_vector[i];

		_solution.scalar_fitness = fit;
	}


	std::vector<double> weights;

};

#endif